gtkmm: Gtk::SpinButton Class Reference

gtkmm 3.5.6

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Related Functions
Gtk::SpinButton Class Reference
Widgets

numeric Entry with up/down buttons Slightly misnamed, this should be called a SpinEntry. More...

Inheritance diagram for Gtk::SpinButton:
[legend]

List of all members.

## Public Member Functions
virtual | ~SpinButton ()
GtkSpinButton* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkSpinButton* | gobj () const
| Provides access to the underlying C GtkObject.
| SpinButton (double climb_rate=0.0, guint digits=0)
| SpinButton (const Glib::RefPtr< Adjustment >& adjustment, double climb_rate=0.0, guint digits=0)
void | configure (const Glib::RefPtr< Adjustment >& adjustment, double climb_rate, guint digits)
| Changes the properties of an existing spin button.
void | set_adjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Replaces the Gtk::Adjustment associated with spin_button.
void | unset_adjustment ()
Glib::RefPtr< Adjustment > | get_adjustment ()
| Get the adjustment associated with a Gtk::SpinButton.
Glib::RefPtr< const Adjustment > | get_adjustment () const
| Get the adjustment associated with a Gtk::SpinButton.
void | set_digits (guint digits)
| Set the precision to be displayed by spin_button.
guint | get_digits () const
| Fetches the precision of spin_button.
void | set_increments (double step, double page)
| Sets the step and page increments for spin_button.
void | get_increments (double& step, double& page) const
| Gets the current step and page the increments used by spin_button.
void | set_range (double min, double max)
| Sets the minimum and maximum allowable values for spin_button.
void | get_range (double&min, double&max) const
| Gets the range allowed for spin_button.
double | get_value () const
| Get the value in the spin_button.
int | get_value_as_int () const
| Get the value spin_button represented as an integer.
void | set_value (double value)
| Sets the value of spin_button.
void | set_update_policy (SpinButtonUpdatePolicy policy)
| Sets the update behavior of a spin button.
SpinButtonUpdatePolicy | get_update_policy () const
| Gets the update behavior of a spin button.
void | set_numeric (bool numeric=true)
| Sets the flag that determines if non-numeric text can be typed into the spin button.
bool | get_numeric () const
| Returns whether non-numeric text can be typed into the spin button.
void | spin (SpinType direction, double increment)
| Increment or decrement a spin button's value in a specified direction by a specified amount.
void | set_wrap (bool wrap=true)
| Sets the flag that determines if a spin button value wraps around to the opposite limit when the upper or lower limit of the range is exceeded.
bool | get_wrap () const
| Returns whether the spin button's value wraps around to the opposite limit when the upper or lower limit of the range is exceeded.
void | set_snap_to_ticks (bool snap_to_ticks=true)
| Sets the policy as to whether values are corrected to the nearest step increment when a spin button is activated after providing an invalid value.
bool | get_snap_to_ticks () const
| Returns whether the values are corrected to the nearest step.
void | update ()
| Manually force an update of the spin button.
Glib::SignalProxy1< int, double* > | signal_input ()
Glib::SignalProxy0< bool > | signal_output ()
Glib::SignalProxy0< void > | signal_wrapped ()
Glib::SignalProxy0< void > | signal_value_changed ()
Glib::PropertyProxy < Glib::RefPtr< Adjustment > > | property_adjustment ()
| The adjustment that holds the value of the spin button.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Adjustment > > | property_adjustment () const
| The adjustment that holds the value of the spin button.
Glib::PropertyProxy< double > | property_climb_rate ()
| The acceleration rate when you hold down a button.
Glib::PropertyProxy_ReadOnly < double > | property_climb_rate () const
| The acceleration rate when you hold down a button.
Glib::PropertyProxy< guint > | property_digits ()
| The number of decimal places to display.
Glib::PropertyProxy_ReadOnly < guint > | property_digits () const
| The number of decimal places to display.
Glib::PropertyProxy< bool > | property_snap_to_ticks ()
| Whether erroneous values are automatically changed to a spin button's nearest step increment.
Glib::PropertyProxy_ReadOnly < bool > | property_snap_to_ticks () const
| Whether erroneous values are automatically changed to a spin button's nearest step increment.
Glib::PropertyProxy< bool > | property_numeric ()
| Whether non-numeric characters should be ignored.
Glib::PropertyProxy_ReadOnly < bool > | property_numeric () const
| Whether non-numeric characters should be ignored.
Glib::PropertyProxy< bool > | property_wrap ()
| Whether a spin button should wrap upon reaching its limits.
Glib::PropertyProxy_ReadOnly < bool > | property_wrap () const
| Whether a spin button should wrap upon reaching its limits.
Glib::PropertyProxy < SpinButtonUpdatePolicy > | property_update_policy ()
| Whether the spin button should update always, or only when the value is legal.
Glib::PropertyProxy_ReadOnly < SpinButtonUpdatePolicy > | property_update_policy () const
| Whether the spin button should update always, or only when the value is legal.
Glib::PropertyProxy< double > | property_value ()
| Reads the current value, or sets a new value.
Glib::PropertyProxy_ReadOnly < double > | property_value () const
| Reads the current value, or sets a new value.
Public Member Functions inherited from Gtk::Entry
virtual | ~Entry ()
| Entry ()
| Entry (const Glib::RefPtr< EntryBuffer >& buffer)
Glib::RefPtr< EntryBuffer > | get_buffer ()
| Get the Gtk::EntryBuffer object which holds the text for this widget.
Glib::RefPtr< const EntryBuffer > | get_buffer () const
| Get the Gtk::EntryBuffer object which holds the text for this widget.
Gdk::Rectangle | get_text_area () const
| Returns the area where the entry's text is drawn.
void | set_buffer (const Glib::RefPtr< EntryBuffer >& buffer)
| Set the Gtk::EntryBuffer object which holds the text for this widget.
void | set_visibility (bool visible=true)
| Sets whether the contents of the entry are visible or not.
bool | get_visibility () const
| Retrieves whether the text in entry is visible.
void | set_invisible_char (gunichar ch)
| Sets the character to use in place of the actual text when set_visibility() has been called to set text visibility to `false`.
void | unset_invisible_char ()
| Unsets the invisible char previously set with set_invisible_char().
gunichar | get_invisible_char () const
| Retrieves the character displayed in place of the real characters for entries with visibility set to false.
void | set_has_frame (bool setting=true)
| Sets whether the entry has a beveled frame around it.
bool | get_has_frame () const
| Gets the value set by set_has_frame().
void | set_inner_border (const Border& border)
| Sets entry's inner-border property to border, or clears it if `0` is passed.
Border | get_inner_border () const
| This function returns the entry's Gtk::Entry::property_inner_border() property.
void | set_overwrite_mode (bool overwrite=true)
| Sets whether the text is overwritten when typing in the Gtk::Entry.
bool | get_overwrite_mode () const
| Gets the value set by set_overwrite_mode().
void | set_max_length (int max)
| Sets the maximum allowed length of the contents of the widget.
int | get_max_length () const
| Retrieves the maximum allowed length of the text in entry.
guint16 | get_text_length () const
| Retrieves the current length of the text in entry.
void | set_activates_default (bool setting=true)
| If setting is `true`, pressing Enter in the entry will activate the default widget for the window containing the entry.
gboolean | get_activates_default () const
| Retrieves the value set by set_activates_default().
void | set_width_chars (int n_chars)
| Changes the size request of the entry to be about the right size for n_chars characters.
int | get_width_chars () const
| Gets the value set by set_width_chars().
void | set_text (const Glib::ustring& text)
| Sets the text in the widget to the given value, replacing the current contents.
Glib::ustring | get_text () const
| Retrieves the contents of the entry widget.
Glib::RefPtr< Pango::Layout > | get_layout ()
| Gets the Pango::Layout used to display the entry.
Glib::RefPtr< const Pango::Layout > | get_layout () const
| Gets the Pango::Layout used to display the entry.
void | get_layout_offsets (int& x, int& y)
| Obtains the position of the Pango::Layout used to render text in the entry, in widget coordinates.
int | layout_index_to_text_index (int layout_index) const
| Converts from a position in the entry contents (returned by get_text()) to a position in the entry's Pango::Layout (returned by get_layout(), with text retrieved via pango_layout_get_text()).
int | text_index_to_layout_index (int text_index) const
| Converts from a position in the entry's Pango::Layout (returned by get_layout()) to a position in the entry contents (returned by get_text()).
void | set_cursor_hadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to the cursor position in an entry, so that when the cursor is moved, the adjustment is scrolled to show that position.
Glib::RefPtr< Adjustment > | get_cursor_hadjustment ()
| Retrieves the horizontal cursor adjustment for the entry.
Glib::RefPtr< const Adjustment > | get_cursor_hadjustment () const
| Retrieves the horizontal cursor adjustment for the entry.
void | set_alignment (float xalign)
| Sets the alignment for the contents of the entry.
void | set_alignment (Align xalign)
| Sets the alignment for the contents of the entry.
float | get_alignment () const
| Gets the value set by set_alignment().
void | set_completion (const Glib::RefPtr< EntryCompletion >& completion)
| Sets completion to be the auxiliary completion object to use with entry.
Glib::RefPtr< EntryCompletion > | get_completion ()
| Returns the auxiliary completion object currently in use by entry.
Glib::RefPtr< const EntryCompletion > | get_completion () const
| Returns the auxiliary completion object currently in use by entry.
void | set_progress_fraction (double fraction)
| Causes the entry's progress indicator to "fill in" the given fraction of the bar.
double | get_progress_fraction () const
| Returns the current fraction of the task that's been completed.
void | set_progress_pulse_step (double fraction)
| Sets the fraction of total entry width to move the progress bouncing block for each call to progress_pulse().
double | get_progress_pulse_step ()
| Retrieves the pulse step set with set_progress_pulse_step().
void | progress_pulse ()
| Indicates that some progress is made, but you don't know how much.
Glib::ustring | get_placeholder_text () const
| Retrieves the text that will be displayed when entry is empty and unfocused.
void | set_placeholder_text (const Glib::ustring& text)
| Sets text to be displayed in entry when it is empty and unfocused.
void | set_icon_from_pixbuf (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets the icon shown in the specified position using a pixbuf.
void | set_icon_from_stock (const StockID& stock_id, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets the icon shown in the entry at the specified position from a stock image.
void | set_icon_from_icon_name (const Glib::ustring& icon_name, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets the icon shown in the entry at the specified position from the current icon theme.
void | set_icon_from_gicon (const Glib::RefPtr< Gio::Icon >& icon, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets the icon shown in the entry at the specified position from the current icon theme.
void | unset_icon (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Do not show any icon in the specified position.
ImageType | get_icon_storage_type (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Gets the type of representation being used by the icon to store image data.
Glib::RefPtr< Gdk::Pixbuf > | get_icon_pixbuf (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Retrieves the image used for the icon.
Glib::RefPtr< const Gdk::Pixbuf > | get_icon_pixbuf (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Retrieves the image used for the icon.
StockID | get_icon_stock (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Retrieves the stock id used for the icon, or `0` if there is no icon or if the icon was set by some other method (e.g., by pixbuf, icon name or gicon).
Glib::ustring | get_icon_name (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Retrieves the icon name used for the icon, or `0` if there is no icon or if the icon was set by some other method (e.g., by pixbuf, stock or gicon).
Glib::RefPtr< Gio::Icon > | get_icon_gicon (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Retrieves the Icon used for the icon, or `0` if there is no icon or if the icon was set by some other method (e.g., by stock, pixbuf, or icon name).
Glib::RefPtr< const Gio::Icon > | get_icon_gicon (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Retrieves the Icon used for the icon, or `0` if there is no icon or if the icon was set by some other method (e.g., by stock, pixbuf, or icon name).
void | set_icon_activatable (bool activatable=true, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets whether the icon is activatable.
bool | get_icon_activatable (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Returns whether the icon is activatable.
void | set_icon_sensitive (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY, bool sensitive=true)
| Sets the sensitivity for the specified icon.
bool | get_icon_sensitive (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Returns whether the icon appears sensitive or insensitive.
int | get_icon_at_pos (int x, int y) const
| Finds the icon at the given position and return its index.
void | set_icon_tooltip_text (const Glib::ustring& tooltip, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets tooltip as the contents of the tooltip for the icon at the specified position.
Glib::ustring | get_icon_tooltip_text (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Gets the contents of the tooltip on the icon at the specified position in entry.
void | set_icon_tooltip_markup (const Glib::ustring& tooltip, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets tooltip as the contents of the tooltip for the icon at the specified position.
Glib::ustring | get_icon_tooltip_markup (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Gets the contents of the tooltip on the icon at the specified position in entry.
void | set_icon_drag_source (const Glib::RefPtr< TargetList >& target_list, Gdk::DragAction actions=Gdk::ACTION_COPY, EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY)
| Sets up the icon at the given position so that GTK+ will start a drag operation when the user clicks and drags the icon.
Gdk::Rectangle | get_icon_area (EntryIconPosition icon_pos=ENTRY_ICON_PRIMARY) const
| Returns the area where entry's icon at icon_pos is drawn.
int | get_current_icon_drag_source ()
| Returns the index of the icon which is the source of the current DND operation, or -1.
bool | im_context_filter_keypress (GdkEventKey*event)
| Allow the Gtk::Entry input method to internally handle key press and release events.
void | reset_im_context ()
| Reset the input method context of the entry if needed.
Glib::SignalProxy1< void, Menu* > | signal_populate_popup ()
Glib::SignalProxy1< void, const Glib::ustring& > | signal_insert_at_cursor ()
Glib::SignalProxy0< void > | signal_activate ()
Glib::SignalProxy2< void, EntryIconPosition, const GdkEventButton* > | signal_icon_release ()
Glib::SignalProxy2< void, EntryIconPosition, const GdkEventButton* > | signal_icon_press ()
Glib::PropertyProxy < Glib::RefPtr< EntryBuffer > > | property_buffer ()
| Text buffer object which actually stores entry text.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< EntryBuffer > > | property_buffer () const
| Text buffer object which actually stores entry text.
Glib::PropertyProxy_ReadOnly< int > | property_cursor_position () const
| The current position of the insertion cursor in chars.
Glib::PropertyProxy_ReadOnly< int > | property_selection_bound () const
| The position of the opposite end of the selection from the cursor in chars.
Glib::PropertyProxy< bool > | property_editable ()
| Whether the entry contents can be edited.
Glib::PropertyProxy_ReadOnly < bool > | property_editable () const
| Whether the entry contents can be edited.
Glib::PropertyProxy< int > | property_max_length ()
| Maximum number of characters for this entry.
Glib::PropertyProxy_ReadOnly< int > | property_max_length () const
| Maximum number of characters for this entry.
Glib::PropertyProxy< bool > | property_visibility ()
| FALSE displays the 'invisible char' instead of the actual text (password mode).
Glib::PropertyProxy_ReadOnly < bool > | property_visibility () const
| FALSE displays the 'invisible char' instead of the actual text (password mode).
Glib::PropertyProxy< bool > | property_has_frame ()
| FALSE removes outside bevel from entry.
Glib::PropertyProxy_ReadOnly < bool > | property_has_frame () const
| FALSE removes outside bevel from entry.
Glib::PropertyProxy< Border > | property_inner_border ()
| Border between text and frame.
Glib::PropertyProxy_ReadOnly < Border > | property_inner_border () const
| Border between text and frame.
Glib::PropertyProxy< gunichar > | property_invisible_char ()
| The character to use when masking entry contents (in 'password mode').
Glib::PropertyProxy_ReadOnly < gunichar > | property_invisible_char () const
| The character to use when masking entry contents (in 'password mode').
Glib::PropertyProxy< bool > | property_invisible_char_set ()
| Whether the invisible character has been set.
Glib::PropertyProxy_ReadOnly < bool > | property_invisible_char_set () const
| Whether the invisible character has been set.
Glib::PropertyProxy< bool > | property_activates_default ()
| Whether to activate the default widget (such as the default button in a dialog) when Enter is pressed.
Glib::PropertyProxy_ReadOnly < bool > | property_activates_default () const
| Whether to activate the default widget (such as the default button in a dialog) when Enter is pressed.
Glib::PropertyProxy< int > | property_width_chars ()
| Number of characters to leave space for in the entry.
Glib::PropertyProxy_ReadOnly< int > | property_width_chars () const
| Number of characters to leave space for in the entry.
Glib::PropertyProxy_ReadOnly< int > | property_scroll_offset () const
| Number of pixels of the entry scrolled off the screen to the left.
Glib::PropertyProxy< ShadowType > | property_shadow_type ()
| Which kind of shadow to draw around the entry when has-frame is set.
Glib::PropertyProxy_ReadOnly < ShadowType > | property_shadow_type () const
| Which kind of shadow to draw around the entry when has-frame is set.
Glib::PropertyProxy < Glib::ustring > | property_text ()
| The contents of the entry.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_text () const
| The contents of the entry.
Glib::PropertyProxy< float > | property_xalign ()
| The horizontal alignment, from 0 (left) to 1 (right).
Glib::PropertyProxy_ReadOnly < float > | property_xalign () const
| The horizontal alignment, from 0 (left) to 1 (right).
Glib::PropertyProxy< bool > | property_truncate_multiline ()
| Whether to truncate multiline pastes to one line.
Glib::PropertyProxy_ReadOnly < bool > | property_truncate_multiline () const
| Whether to truncate multiline pastes to one line.
Glib::PropertyProxy< bool > | property_overwrite_mode ()
| Whether new text overwrites existing text.
Glib::PropertyProxy_ReadOnly < bool > | property_overwrite_mode () const
| Whether new text overwrites existing text.
Glib::PropertyProxy_ReadOnly < guint > | property_text_length () const
| Length of the text currently in the entry.
Glib::PropertyProxy< bool > | property_caps_lock_warning ()
| Whether password entries will show a warning when Caps Lock is on.
Glib::PropertyProxy_ReadOnly < bool > | property_caps_lock_warning () const
| Whether password entries will show a warning when Caps Lock is on.
Glib::PropertyProxy< double > | property_progress_fraction ()
| The current fraction of the task that's been completed.
Glib::PropertyProxy_ReadOnly < double > | property_progress_fraction () const
| The current fraction of the task that's been completed.
Glib::PropertyProxy< double > | property_progress_pulse_step ()
| The fraction of total entry width to move the progress bouncing block for each call to gtk_entry_progress_pulse().
Glib::PropertyProxy_ReadOnly < double > | property_progress_pulse_step () const
| The fraction of total entry width to move the progress bouncing block for each call to gtk_entry_progress_pulse().
Glib::PropertyProxy < Glib::RefPtr< Gdk::Pixbuf > > | property_primary_icon_pixbuf ()
| Primary pixbuf for the entry.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Pixbuf > > | property_primary_icon_pixbuf () const
| Primary pixbuf for the entry.
Glib::PropertyProxy < Glib::RefPtr< Gdk::Pixbuf > > | property_secondary_icon_pixbuf ()
| Secondary pixbuf for the entry.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Pixbuf > > | property_secondary_icon_pixbuf () const
| Secondary pixbuf for the entry.
Glib::PropertyProxy< StockID > | property_primary_icon_stock ()
| Stock ID for primary icon.
Glib::PropertyProxy_ReadOnly < StockID > | property_primary_icon_stock () const
| Stock ID for primary icon.
Glib::PropertyProxy< StockID > | property_secondary_icon_stock ()
| Stock ID for secondary icon.
Glib::PropertyProxy_ReadOnly < StockID > | property_secondary_icon_stock () const
| Stock ID for secondary icon.
Glib::PropertyProxy < Glib::ustring > | property_primary_icon_name ()
| Icon name for primary icon.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_primary_icon_name () const
| Icon name for primary icon.
Glib::PropertyProxy < Glib::ustring > | property_secondary_icon_name ()
| Icon name for secondary icon.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_secondary_icon_name () const
| Icon name for secondary icon.
Glib::PropertyProxy < Glib::RefPtr< Gio::Icon > > | property_primary_icon_gicon ()
| GIcon for primary icon.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gio::Icon > > | property_primary_icon_gicon () const
| GIcon for primary icon.
Glib::PropertyProxy < Glib::RefPtr< Gio::Icon > > | property_secondary_icon_gicon ()
| GIcon for secondary icon.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gio::Icon > > | property_secondary_icon_gicon () const
| GIcon for secondary icon.
Glib::PropertyProxy_ReadOnly < ImageType > | property_primary_icon_storage_type () const
| The representation being used for primary icon.
Glib::PropertyProxy_ReadOnly < ImageType > | property_secondary_icon_storage_type () const
| The representation being used for secondary icon.
Glib::PropertyProxy< bool > | property_primary_icon_activatable ()
| Whether the primary icon is activatable.
Glib::PropertyProxy_ReadOnly < bool > | property_primary_icon_activatable () const
| Whether the primary icon is activatable.
Glib::PropertyProxy< bool > | property_secondary_icon_activatable ()
| Whether the secondary icon is activatable.
Glib::PropertyProxy_ReadOnly < bool > | property_secondary_icon_activatable () const
| Whether the secondary icon is activatable.
Glib::PropertyProxy< bool > | property_primary_icon_sensitive ()
| Whether the primary icon is sensitive.
Glib::PropertyProxy_ReadOnly < bool > | property_primary_icon_sensitive () const
| Whether the primary icon is sensitive.
Glib::PropertyProxy< bool > | property_secondary_icon_sensitive ()
| Whether the secondary icon is sensitive.
Glib::PropertyProxy_ReadOnly < bool > | property_secondary_icon_sensitive () const
| Whether the secondary icon is sensitive.
Glib::PropertyProxy< bool > | property_primary_icon_tooltip_text ()
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy_ReadOnly < bool > | property_primary_icon_tooltip_text () const
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy< bool > | property_secondary_icon_tooltip_text ()
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy_ReadOnly < bool > | property_secondary_icon_tooltip_text () const
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy< bool > | property_primary_icon_tooltip_markup ()
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy_ReadOnly < bool > | property_primary_icon_tooltip_markup () const
| The contents of the tooltip on the primary icon.
Glib::PropertyProxy< bool > | property_secondary_icon_tooltip_markup ()
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy_ReadOnly < bool > | property_secondary_icon_tooltip_markup () const
| The contents of the tooltip on the secondary icon.
Glib::PropertyProxy < Glib::ustring > | property_im_module ()
| Which IM module should be used.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_im_module () const
| Which IM module should be used.
Glib::PropertyProxy < Glib::ustring > | property_placeholder_text ()
| Show text in the entry when it's empty and unfocused.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_placeholder_text () const
| Show text in the entry when it's empty and unfocused.
Glib::PropertyProxy < Glib::RefPtr < EntryCompletion > > | property_completion ()
| The auxiliary completion object.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr < EntryCompletion > > | property_completion () const
| The auxiliary completion object.
Public Member Functions inherited from Gtk::Widget
virtual | ~Widget ()
| Destroys the widget.
void | show ()
| Flags a widget to be displayed.
void | show_now ()
| Shows a widget.
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user).
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container).
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget.
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates.
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the rectangular area of widget defined by region by calling gdk_window_invalidate_region() on the widget's window and all its child windows.
void | queue_resize ()
| This function is only for use in widget implementations.
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Retrieves a widget's initial minimum and natural width.
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget's minimum and natural height if it would be given the specified width.
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Retrieves a widget's initial minimum and natural height.
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget's minimum and natural width if it would be given the specified height.
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget's preference for height-for-width management.
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator().
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal.
bool | event (GdkEvent* event)
| Rarely-used function.
int | send_expose (GdkEvent*event)
| Very rarely-used function.
bool | send_focus_change (GdkEvent*event)
| Sends the focus change event to widget.
bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.) this function activates them.
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region >& region) const
| Computes the intersection of a widget's area and region, returning the intersection.
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget.
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the child property child_property on widget.
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify().
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus.
bool | get_can_focus () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside.
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget.
bool | get_can_default () const
| Determines whether widget can be a default widget.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | grab_default ()
| Causes widget to become the default widget.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is alyways treated as default widget withing its toplevel when it has the focus, even if another widget is the default.
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse).
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget.
void | add_modal_grab ()
| Block events to everything else than this widget and its children.
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed.
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state (StateType state)
| This function is for use in widget implementations.
StateType | get_state () const
| Returns the widget's state.
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations.
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget's sensitivity (in the sense of returning the value that has been set using set_sensitive()).
bool | is_sensitive () const
| Returns the widget's effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own.
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget.
bool | get_is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler.
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering.
bool | get_double_buffered () const
| Determines whether the widget is double buffered.
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes.
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().
bool | get_child_visible () const
| Gets the value set with set_child_visible().
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget's window if it is realized, `0` otherwise.
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget's window if it is realized, `0` otherwise.
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget's location.
void | set_allocation (const Allocation& allocation)
| Sets the widget's allocation.
Container* | get_parent ()
| Returns the parent container of widget.
const Container* | get_parent () const
| Returns the parent container of widget.
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget's parent window.
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget's parent window.
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget.
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height.
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget.
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget.
void | set_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget.
void | add_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget.
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children.
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children.
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of.
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of.
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget.
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget.
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located.
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget.
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used.
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware.
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness.
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology.
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology.
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property.
void | set_margin_left (int margin)
| Sets the left margin of widget.
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property.
void | set_margin_right (int margin)
| Sets the right margin of widget.
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
Gdk::EventMask | get_events () const
| Returns the event mask for the widget (a bitfield containing flags from the Gdk::EventMask enumeration).
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns the events mask for the widget corresponding to an specific device.
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates.
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.
void | override_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_color (StateFlags state=(StateFlags) 0)
void | override_background_color (const Gdk::RGBA& color, StateFlags state=(StateFlags) 0)
void | unset_background_color (StateFlags state=(StateFlags) 0)
void | override_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget.
void | unset_font ()
void | override_symbolic_color (const Glib::ustring& name, const Gdk::RGBA& color)
| Sets a symbolic color for a widget.
void | unset_symbolic_color (const Glib::ustring& name)
void | override_cursor (const Gdk::RGBA& cursor, const Gdk::RGBA& secondary_cursor)
| Sets the cursor color to use in a widget, overriding the Gtk::Widget::property_cursor_color() and Gtk::Widget::property_secondary_cursor_color() style properties.
void | unset_cursor ()
void | reset_style ()
| Updates the style context of widget and all descendents by updating its widget path.
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType&value) const
| Gets the value of a style property of widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID& stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf.
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name.
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget's GDK window.
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget's GDK window.
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created.
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()).
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget.
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
| Gets the data associated with a drag.
void | drag_highlight ()
| Draws a highlight around a widget.
void | drag_unhighlight ()
| Removes a highlight set by gtk_drag_highlight() from a widget.
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
| Sets this widget as a proxy for drops to another window.
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set().
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop.
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop.
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop.
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
| Undoes the effects of set().
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon.
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon.
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source.
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent*event)
| Initiates a drag on the source side.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation.
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated.
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget.
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container.
void | unparent ()
| This function is only for use in widget implementations.
void | map ()
| This function is only for use in widget implementations.
void | unmap ()
| This function is only for use in widget implementations.
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
| Draws a text caret on cr at location.
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window.
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget.
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget's windowing system backend uses for a particular purpose.
Glib::SignalProxy0< void > | signal_show ()
Glib::SignalProxy0< void > | signal_hide ()
Glib::SignalProxy0< void > | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy0< void > | signal_unmap ()
Glib::SignalProxy0< void > | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy0< void > | signal_unrealize ()
Glib::SignalProxy1< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy1< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy1< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy1< void, Widget* > | signal_parent_changed ()
| Informs objects that their parent changed.
Glib::SignalProxy1< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy0< void > | signal_style_updated ()
Glib::SignalProxy1< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy1< void, bool > | signal_grab_notify ()
Glib::SignalProxy1< void, GParamSpec* > | signal_child_notify ()
Glib::SignalProxy1< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy0< void > | signal_grab_focus ()
Glib::SignalProxy1< bool, DirectionType > | signal_focus ()
Glib::SignalProxy1< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy1< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_press_event ()
| Event triggered by user pressing button.
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_release_event ()
| Event triggered by user releasing button.
Glib::SignalProxy1< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy1< bool, GdkEventMotion* > | signal_motion_notify_event ()
| Event triggered by user moving pointer.
Glib::SignalProxy1< bool, GdkEventAny* > | signal_delete_event ()
Glib::SignalProxy1< bool, const ::Cairo::RefPtr < ::Cairo::Context >& > | signal_draw ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_press_event ()
| Event triggered by a key press will widget has focus.
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_release_event ()
| Event triggered by a key release will widget has focus.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area.
Glib::SignalProxy1< bool, GdkEventConfigure* > | signal_configure_event ()
| Event triggered by a window resizing.
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy1< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy1< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy1< bool, GdkEventWindowState* > | signal_window_state_event ()
Glib::SignalProxy3< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy2< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_begin ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_end ()
Glib::SignalProxy4< void, const Glib::RefPtr < Gdk::DragContext > &, SelectionData&, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::DragContext >& > | signal_drag_data_delete ()
Glib::SignalProxy2< bool, const Glib::RefPtr < Gdk::DragContext > &, DragResult > | signal_drag_failed ()
Glib::SignalProxy2< void, const Glib::RefPtr < Gdk::DragContext >&, guint > | signal_drag_leave ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy4< bool, const Glib::RefPtr < Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy6< void, const Glib::RefPtr < Gdk::DragContext >&, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gdk::Screen >& > | signal_screen_changed ()
Glib::SignalProxy0< void > | signal_composited_changed ()
Glib::SignalProxy0< bool > | signal_popup_menu ()
Glib::SignalProxy4< bool, int, int, bool, const Glib::RefPtr < Tooltip >& > | signal_query_tooltip ()
Glib::SignalProxy1< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy1< bool, GdkEventTouch* > | signal_touch_event ()
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly < Container* > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget.
Glib::PropertyProxy_ReadOnly < bool > | property_app_paintable () const
| Whether the application will paint directly on the widget.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_can_focus () const
| Whether the widget can accept the input focus.
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus.
Glib::PropertyProxy_ReadOnly < bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy_ReadOnly < bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel.
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_can_default () const
| Whether the widget can be the default widget.
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget.
Glib::PropertyProxy_ReadOnly < bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly < bool > | property_composite_child () const
| Whether the widget is part of a composite widget.
Glib::PropertyProxy < Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors etc).
Glib::PropertyProxy < Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy_ReadOnly < Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Whether this widget has a tooltip.
Glib::PropertyProxy_ReadOnly < bool > | property_has_tooltip () const
| Whether this widget has a tooltip.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_markup ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_markup () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy < Glib::ustring > | property_tooltip_text ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_tooltip_text () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized.
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy_ReadOnly < bool > | property_no_show_all () const
| Whether gtk_widget_show_all() should not affect this widget.
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered.
Glib::PropertyProxy_ReadOnly < bool > | property_double_buffered () const
| Whether the widget is double buffered.
Glib::PropertyProxy< Align > | property_halign ()
| How to position in extra horizontal space.
Glib::PropertyProxy_ReadOnly < Align > | property_halign () const
| How to position in extra horizontal space.
Glib::PropertyProxy< Align > | property_valign ()
| How to position in extra vertical space.
Glib::PropertyProxy_ReadOnly < Align > | property_valign () const
| How to position in extra vertical space.
Glib::PropertyProxy< int > | property_margin_left ()
| Pixels of extra space on the left side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Pixels of extra space on the left side.
Glib::PropertyProxy< int > | property_margin_right ()
| Pixels of extra space on the right side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Pixels of extra space on the right side.
Glib::PropertyProxy< int > | property_margin_top ()
| Pixels of extra space on the top side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Pixels of extra space on the top side.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Pixels of extra space on the bottom side.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Pixels of extra space on the bottom side.
Glib::PropertyProxy< int > | property_margin ()
| Pixels of extra space on all four sides.
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Pixels of extra space on all four sides.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether widget wants more horizontal space.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand () const
| Whether widget wants more horizontal space.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether widget wants more vertical space.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand () const
| Whether widget wants more vertical space.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly < bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< bool > | property_expand ()
| Whether widget wants to expand in both directions.
Glib::PropertyProxy_ReadOnly < bool > | property_expand () const
| Whether widget wants to expand in both directions.
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()
Public Member Functions inherited from Gtk::Buildable
virtual | ~Buildable ()
Public Member Functions inherited from Glib::Interface
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
virtual | ~Interface ()
Public Member Functions inherited from Gtk::Editable
virtual | ~Editable ()
void | cut_clipboard ()
| Removes the contents of the currently selected content in the editable and puts it on the clipboard.
void | copy_clipboard ()
| Copies the contents of the currently selected content in the editable and puts it on the clipboard.
void | paste_clipboard ()
| Pastes the content of the clipboard to the current position of the cursor in the editable.
void | delete_selection ()
| Deletes the currently selected text of the editable.
void | set_editable (bool is_editable=true)
| Determines if the user can edit the text in the editable widget or not.
bool | get_editable () const
| Retrieves whether editable is editable.
void | insert_text (const Glib::ustring& text, int length, int& position)
| Inserts new_text_length bytes of new_text into the contents of the widget, at position position.
void | delete_text (int start_pos, int end_pos)
| Deletes a sequence of characters.
Glib::ustring | get_chars (int start_pos, int end_pos) const
| Retrieves a sequence of characters.
void | select_region (int start_pos, int end_pos)
| Selects a region of text.
bool | get_selection_bounds (int& start_pos, int& end_pos) const
| Retrieves the selection bound of the editable.
void | set_position (int position)
| Sets the cursor position in the editable to the given value.
int | get_position () const
| Retrieves the current position of the cursor relative to the start of the content of the editable.
Glib::SignalProxy2< void, const Glib::ustring&, int* > | signal_insert_text ()
Glib::SignalProxy2< void, int, int > | signal_delete_text ()
Glib::SignalProxy0< void > | signal_changed ()
Public Member Functions inherited from Gtk::CellEditable
virtual | ~CellEditable ()
void | start_editing (GdkEvent* event)
| Begins editing on a cell_editable.
void | editing_done ()
| Emits the Gtk::CellEditable::signal_editing_done() signal.
void | remove_widget ()
| Emits the Gtk::CellEditable::signal_remove_widget() signal.
Glib::SignalProxy0< void > | signal_editing_done ()
Glib::SignalProxy0< void > | signal_remove_widget ()
Glib::PropertyProxy< bool > | property_editing_canceled ()
| Indicates that editing has been canceled.
Glib::PropertyProxy_ReadOnly < bool > | property_editing_canceled () const
| Indicates that editing has been canceled.

## Protected Member Functions
virtual int | on_input (double* new_value)
| This is a default handler for the signal signal_input().
virtual bool | on_output ()
| This is a default handler for the signal signal_output().
virtual void | on_wrapped ()
| This is a default handler for the signal signal_wrapped().
virtual void | on_value_changed ()
| This is a default handler for the signal signal_value_changed().
Protected Member Functions inherited from Gtk::Entry
virtual void | on_populate_popup (Menu* menu)
| This is a default handler for the signal signal_populate_popup().
virtual void | on_insert_at_cursor (const Glib::ustring& str)
| This is a default handler for the signal signal_insert_at_cursor().
virtual void | on_activate ()
| This is a default handler for the signal signal_activate().
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate().
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed().
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed().
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed().
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify().
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus().
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus().
virtual bool | on_event (GdkEvent*event)
| This is a default handler for the signal signal_event().
virtual bool | on_button_press_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_press_event().
virtual bool | on_button_release_event (GdkEventButton*event)
| This is a default handler for the signal signal_button_release_event().
virtual bool | on_scroll_event (GdkEventScroll*event)
| This is a default handler for the signal signal_scroll_event().
virtual bool | on_motion_notify_event (GdkEventMotion*event)
| This is a default handler for the signal signal_motion_notify_event().
virtual bool | on_delete_event (GdkEventAny*event)
| This is a default handler for the signal signal_delete_event().
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| This is a default handler for the signal signal_draw().
virtual bool | on_key_press_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_press_event().
virtual bool | on_key_release_event (GdkEventKey*event)
| This is a default handler for the signal signal_key_release_event().
virtual bool | on_enter_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_enter_notify_event().
virtual bool | on_leave_notify_event (GdkEventCrossing*event)
| This is a default handler for the signal signal_leave_notify_event().
virtual bool | on_configure_event (GdkEventConfigure*event)
| This is a default handler for the signal signal_configure_event().
virtual bool | on_focus_in_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_in_event().
virtual bool | on_focus_out_event (GdkEventFocus*event)
| This is a default handler for the signal signal_focus_out_event().
virtual bool | on_map_event (GdkEventAny*event)
| This is a default handler for the signal signal_map_event().
virtual bool | on_unmap_event (GdkEventAny*event)
| This is a default handler for the signal signal_unmap_event().
virtual bool | on_property_notify_event (GdkEventProperty*event)
| This is a default handler for the signal signal_property_notify_event().
virtual bool | on_selection_clear_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_clear_event().
virtual bool | on_selection_request_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_request_event().
virtual bool | on_selection_notify_event (GdkEventSelection*event)
| This is a default handler for the signal signal_selection_notify_event().
virtual bool | on_proximity_in_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_in_event().
virtual bool | on_proximity_out_event (GdkEventProximity*event)
| This is a default handler for the signal signal_proximity_out_event().
virtual bool | on_visibility_notify_event (GdkEventVisibility*event)
| This is a default handler for the signal signal_visibility_notify_event().
virtual bool | on_window_state_event (GdkEventWindowState*event)
| This is a default handler for the signal signal_window_state_event().
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get().
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received().
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin().
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end().
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get().
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete().
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave().
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion().
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop().
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received().
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed().
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int& minimum_width, int& natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget.
void | unrealize ()
| This function is only useful in widget implementations.
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr.
void | set_mapped (bool mapped=true)
| Marks the widget as being realized.
void | set_realized (bool realized=true)
| Marks the widget as being realized.
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own.
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window.
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates.
Requisition | get_requisition () const
| Retrieves the widget's requisition.
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase&value) const
| Gets the value of a style property of widget.
void | realize_if_needed ()
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Editable
| Editable ()
| You should derive from this class to use it.
virtual void | delete_text_vfunc (int start_pos, int end_pos)
virtual Glib::ustring | get_chars_vfunc (int start_pos, int end_pos) const
virtual void | select_region_vfunc (int start_pos, int end_pos)
virtual bool | get_selection_bounds_vfunc (int& start_pos, int& end_pos) const
virtual void | set_position_vfunc (int position)
virtual int | get_position_vfunc () const
virtual void | insert_text_vfunc (const Glib::ustring& text, int& position)
virtual void | on_insert_text (const Glib::ustring& text, int* position)
| This is a default handler for the signal signal_insert_text().
virtual void | on_delete_text (int start_pos, int end_pos)
| This is a default handler for the signal signal_delete_text().
virtual void | on_changed ()
| This is a default handler for the signal signal_changed().
Protected Member Functions inherited from Gtk::CellEditable
| CellEditable ()
| You should derive from this class to use it.
virtual void | start_editing_vfunc (GdkEvent* event)
virtual void | on_editing_done ()
| This is a default handler for the signal signal_editing_done().
virtual void | on_remove_widget ()
| This is a default handler for the signal signal_remove_widget().

## Related Functions
(Note that these are not member functions.)
Gtk::SpinButton* | wrap (GtkSpinButton* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Entry
Gtk::Entry* | wrap (GtkEntry* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::Editable
Glib::RefPtr< Gtk::Editable > | wrap (GtkEditable* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gtk::CellEditable
Glib::RefPtr< Gtk::CellEditable > | wrap (GtkCellEditable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

numeric Entry with up/down buttons Slightly misnamed, this should be called a SpinEntry.

The SpinButton widget looks like this:

## Constructor & Destructor Documentation

virtual Gtk::SpinButton::~SpinButton | ( |  | ) |
| virtual

Gtk::SpinButton::SpinButton | ( | double | climb_rate = `0.0`,
|  | guint | digits = `0`
| ) |  |

Gtk::SpinButton::SpinButton | ( | const Glib::RefPtr< Adjustment >& | adjustment,
|  | double | climb_rate = `0.0`,
|  | guint | digits = `0`
| ) |  |
| explicit

## Member Function Documentation

void Gtk::SpinButton::configure | ( | const Glib::RefPtr< Adjustment >& | adjustment,
|  | double | climb_rate,
|  | guint | digits
| ) |  |

Changes the properties of an existing spin button.

The adjustment, climb rate, and number of decimal places are all changed accordingly, after this function call.

Parameters:

  adjustment | A Gtk::Adjustment.
  climb_rate | The new climb rate.
  digits | The number of decimal places to display in the spin button.

Glib::RefPtr<Adjustment> Gtk::SpinButton::get_adjustment | ( |  | ) |

Get the adjustment associated with a Gtk::SpinButton.

Returns:
  The Gtk::Adjustment of spin_button.

Glib::RefPtr<const Adjustment> Gtk::SpinButton::get_adjustment | ( |  | ) | const

Get the adjustment associated with a Gtk::SpinButton.

Returns:
  The Gtk::Adjustment of spin_button.

guint Gtk::SpinButton::get_digits | ( |  | ) | const

Fetches the precision of spin_button.

See set_digits().

Returns:
  The current precision.

void Gtk::SpinButton::get_increments | ( | double & | step,
|  | double & | page
| ) |  | const

Gets the current step and page the increments used by spin_button.

See set_increments().

Parameters:

  step | Location to store step increment, or `0`.
  page | Location to store page increment, or `0`.

bool Gtk::SpinButton::get_numeric | ( |  | ) | const

Returns whether non-numeric text can be typed into the spin button.

See set_numeric().

Returns:
  `true` if only numeric text can be entered.

void Gtk::SpinButton::get_range | ( | double & | min,
|  | double & | max
| ) |  | const

Gets the range allowed for spin_button.

See set_range().

Parameters:

  min | Location to store minimum allowed value, or `0`.
  max | Location to store maximum allowed value, or `0`.

bool Gtk::SpinButton::get_snap_to_ticks | ( |  | ) | const

Returns whether the values are corrected to the nearest step.

See set_snap_to_ticks().

Returns:
  `true` if values are snapped to the nearest step.

SpinButtonUpdatePolicy Gtk::SpinButton::get_update_policy | ( |  | ) | const

Gets the update behavior of a spin button.

See set_update_policy().

Returns:
  The current update policy.

double Gtk::SpinButton::get_value | ( |  | ) | const

Get the value in the spin_button.

Returns:
  The value of spin_button.

int Gtk::SpinButton::get_value_as_int | ( |  | ) | const

Get the value spin_button represented as an integer.

Returns:
  The value of spin_button.

bool Gtk::SpinButton::get_wrap | ( |  | ) | const

Returns whether the spin button's value wraps around to the opposite limit when the upper or lower limit of the range is exceeded.

See set_wrap().

Returns:
  `true` if the spin button wraps around.

GtkSpinButton* Gtk::SpinButton::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Entry.

const GtkSpinButton* Gtk::SpinButton::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Entry.

virtual int Gtk::SpinButton::on_input | ( | double * | new_value | ) |
| protectedvirtual

This is a default handler for the signal signal_input().

virtual bool Gtk::SpinButton::on_output | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_output().

virtual void Gtk::SpinButton::on_value_changed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_value_changed().

virtual void Gtk::SpinButton::on_wrapped | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_wrapped().

Glib::PropertyProxy< Glib::RefPtr<Adjustment> > Gtk::SpinButton::property_adjustment | ( |  | ) |

The adjustment that holds the value of the spin button.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Adjustment> > Gtk::SpinButton::property_adjustment | ( |  | ) | const

The adjustment that holds the value of the spin button.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< double > Gtk::SpinButton::property_climb_rate | ( |  | ) |

The acceleration rate when you hold down a button.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< double > Gtk::SpinButton::property_climb_rate | ( |  | ) | const

The acceleration rate when you hold down a button.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< guint > Gtk::SpinButton::property_digits | ( |  | ) |

The number of decimal places to display.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< guint > Gtk::SpinButton::property_digits | ( |  | ) | const

The number of decimal places to display.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::SpinButton::property_numeric | ( |  | ) |

Whether non-numeric characters should be ignored.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::SpinButton::property_numeric | ( |  | ) | const

Whether non-numeric characters should be ignored.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::SpinButton::property_snap_to_ticks | ( |  | ) |

Whether erroneous values are automatically changed to a spin button's nearest step increment.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::SpinButton::property_snap_to_ticks | ( |  | ) | const

Whether erroneous values are automatically changed to a spin button's nearest step increment.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< SpinButtonUpdatePolicy > Gtk::SpinButton::property_update_policy | ( |  | ) |

Whether the spin button should update always, or only when the value is legal.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< SpinButtonUpdatePolicy > Gtk::SpinButton::property_update_policy | ( |  | ) | const

Whether the spin button should update always, or only when the value is legal.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< double > Gtk::SpinButton::property_value | ( |  | ) |

Reads the current value, or sets a new value.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< double > Gtk::SpinButton::property_value | ( |  | ) | const

Reads the current value, or sets a new value.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::SpinButton::property_wrap | ( |  | ) |

Whether a spin button should wrap upon reaching its limits.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::SpinButton::property_wrap | ( |  | ) | const

Whether a spin button should wrap upon reaching its limits.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::SpinButton::set_adjustment | ( | const Glib::RefPtr< Adjustment >& | adjustment | ) |

Replaces the Gtk::Adjustment associated with spin_button.

Parameters:

  adjustment | A Gtk::Adjustment to replace the existing adjustment.

void Gtk::SpinButton::set_digits | ( | guint | digits | ) |

Set the precision to be displayed by spin_button.

Up to 20 digit precision is allowed.

Parameters:

  digits | The number of digits after the decimal point to be displayed for the spin button's value.

void Gtk::SpinButton::set_increments | ( | double | step,
|  | double | page
| ) |  |

Sets the step and page increments for spin_button.

This affects how quickly the value changes when the spin button's arrows are activated.

Parameters:

  step | Increment applied for a button 1 press.
  page | Increment applied for a button 2 press.

void Gtk::SpinButton::set_numeric | ( | bool | numeric = `true` | ) |

Sets the flag that determines if non-numeric text can be typed into the spin button.

Parameters:

  numeric | Flag indicating if only numeric entry is allowed.

void Gtk::SpinButton::set_range | ( | double | min,
|  | double | max
| ) |  |

Sets the minimum and maximum allowable values for spin_button.

If the current value is outside this range, it will be adjusted to fit within the range, otherwise it will remain unchanged.

Parameters:

  min | Minimum allowable value.
  max | Maximum allowable value.

void Gtk::SpinButton::set_snap_to_ticks | ( | bool | snap_to_ticks = `true` | ) |

Sets the policy as to whether values are corrected to the nearest step increment when a spin button is activated after providing an invalid value.

Parameters:

  snap_to_ticks | A flag indicating if invalid values should be corrected.

void Gtk::SpinButton::set_update_policy | ( | SpinButtonUpdatePolicy | policy | ) |

Sets the update behavior of a spin button.

This determines wether the spin button is always updated or only when a valid value is set.

Parameters:

  policy | A Gtk::SpinButtonUpdatePolicy value.

void Gtk::SpinButton::set_value | ( | double | value | ) |

Sets the value of spin_button.

Parameters:

  value | The new value.

void Gtk::SpinButton::set_wrap | ( | bool | wrap = `true` | ) |

Sets the flag that determines if a spin button value wraps around to the opposite limit when the upper or lower limit of the range is exceeded.

Parameters:

  wrap | A flag indicating if wrapping behavior is performed.

Glib::SignalProxy1< int,double* > Gtk::SpinButton::signal_input | ( |  | ) |

Slot Prototype:
  `int on_my_input(double* new_value)`

The signal_input() signal can be used to influence the conversion of the users input into a double value. The signal handler is expected to use Gtk::Entry::get_text() to retrieve the text of the entry and set new_value to the new value.

The default conversion uses Glib::strtod().

Parameters:

  new_value | Return location for the new value.

Returns:
  `true` for a successful conversion, `false` if the input was not handled, and Gtk::INPUT_ERROR if the conversion failed.

Glib::SignalProxy0< bool > Gtk::SpinButton::signal_output | ( |  | ) |

Slot Prototype:
  `bool on_my_output()`

The signal_output() signal can be used to change to formatting of the value that is displayed in the spin buttons entry.

[C example ellipted]

Returns:
  `true` if the value has been displayed.

Glib::SignalProxy0< void > Gtk::SpinButton::signal_value_changed | ( |  | ) |

Slot Prototype:
  `void on_my_value_changed()`

Glib::SignalProxy0< void > Gtk::SpinButton::signal_wrapped | ( |  | ) |

Slot Prototype:
  `void on_my_wrapped()`

The wrapped signal is emitted right after the spinbutton wraps from its maximum to minimum value or vice-versa.

Since gtkmm 2.10:

void Gtk::SpinButton::spin | ( | SpinType | direction,
|  | double | increment
| ) |  |

Increment or decrement a spin button's value in a specified direction by a specified amount.

Parameters:

  direction | A Gtk::SpinType indicating the direction to spin.
  increment | Step increment to apply in the specified direction.

void Gtk::SpinButton::unset_adjustment | ( |  | ) |

void Gtk::SpinButton::update | ( |  | ) |

Manually force an update of the spin button.

## Friends And Related Function Documentation

Gtk::SpinButton* wrap | ( | GtkSpinButton * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/spinbutton.h